diff --git a/pslogin/src/main/scala/WorldSessionActor.scala b/pslogin/src/main/scala/WorldSessionActor.scala
index cacf4a97..2f5a03a8 100644
--- a/pslogin/src/main/scala/WorldSessionActor.scala
+++ b/pslogin/src/main/scala/WorldSessionActor.scala
@@ -3603,6 +3622,8 @@ class WorldSessionActor extends Actor with MDCContextAware {
               }
               vehicleService ! VehicleServiceMessage(continent.Id, VehicleAction.VehicleState(player.GUID, vehicle_guid, unk1, pos, ang, vel, flight, unk6, unk7, wheels, unk9, unkA))
             }
+            //vehicleService ! VehicleServiceMessage(continent.Id, VehicleAction.VehicleState(player.GUID, vehicle_guid, unk1, pos, ang, vel, flight, unk6, unk7, wheels, unk9, unkA))
+            updateSquad()
           case (None, _) =>
             //log.error(s"VehicleState: no vehicle $vehicle_guid found in zone")
             //TODO placing a "not driving" warning here may trigger as we are disembarking the vehicle
@@ -4704,24 +4725,28 @@ class WorldSessionActor extends Actor with MDCContextAware {
             log.info(s"GenericObject: $player is MAX with an unexpected weapon - ${definition.Name}")
         }
       }
-      else if(action == 37) { //Looking For Squad OFF
-        if(squadUI.nonEmpty) {
-          lfs = false
-        }
-        else if(avatar.LFS) {
-          avatar.LFS = false
-          avatarService ! AvatarServiceMessage(continent.Id, AvatarAction.PlanetsideAttribute(player.GUID, 53, 0))
-          log.info(s"GenericObject: ${player.Name} is no longer looking for a squad to join")
-        }
-      }
       else if(action == 36) { //Looking For Squad ON
         if(squadUI.nonEmpty) {
-          lfs = true
+          if(!lfs && squadUI(player.CharId).index == 0) {
+            lfs = true
+            avatarService ! AvatarServiceMessage(continent.Id, AvatarAction.PlanetsideAttribute(player.GUID, 53, 1))
+          }
         }
         else if(!avatar.LFS) {
           avatar.LFS = true
           avatarService ! AvatarServiceMessage(continent.Id, AvatarAction.PlanetsideAttribute(player.GUID, 53, 1))
-          log.info(s"GenericObject: ${player.Name} has made himself available to join a squad")
+        }
+      }
+      else if(action == 37) { //Looking For Squad OFF
+        if(squadUI.nonEmpty) {
+          if(lfs && squadUI(player.CharId).index == 0) {
+            lfs = false
+            avatarService ! AvatarServiceMessage(continent.Id, AvatarAction.PlanetsideAttribute(player.GUID, 53, 0))
+          }
+        }
+        else if(avatar.LFS) {
+          avatar.LFS = false
+          avatarService ! AvatarServiceMessage(continent.Id, AvatarAction.PlanetsideAttribute(player.GUID, 53, 0))
         }
       }
 
@@ -9185,17 +9210,15 @@ class WorldSessionActor extends Actor with MDCContextAware {
 
   def SwapSquadUIElements(squad : Squad, fromIndex : Int, toIndex : Int) : Unit = {
     if(squadUI.nonEmpty) {
-      val fromMember = squad.Membership(fromIndex)
+      val fromMember = squad.Membership(toIndex) //the players have already been swapped in the backend object
       val fromCharId = fromMember.CharId
-      val toMember = squad.Membership(toIndex)
+      val toMember = squad.Membership(fromIndex) //the players have already been swapped in the backend object
       val toCharId = toMember.CharId
       val id = 11
-      if(fromCharId > 0) {
+      if(toCharId > 0) {
         //toMember and fromMember have swapped places
         val fromElem = squadUI(fromCharId)
         val toElem = squadUI(toCharId)
-        sendResponse(SquadMemberEvent.Remove(id, toCharId, fromIndex))
-        sendResponse(SquadMemberEvent.Remove(id, fromCharId, toIndex))
         squadUI(toCharId) = SquadUIElement(fromElem.name, toIndex, fromElem.zone, fromElem.health, fromElem.armor, fromElem.position)
         squadUI(fromCharId) = SquadUIElement(toElem.name, fromIndex, toElem.zone, toElem.health, toElem.armor, toElem.position)
         sendResponse(SquadMemberEvent.Add(id, toCharId, toIndex, fromElem.name, fromElem.zone, unk7 = 0))
@@ -9212,14 +9235,14 @@ class WorldSessionActor extends Actor with MDCContextAware {
       }
       else {
         //previous fromMember has moved toMember
-        val elem = squadUI(toCharId)
-        sendResponse(SquadMemberEvent.Remove(id, toCharId, fromIndex))
-        squadUI(toCharId) = SquadUIElement(elem.name, toIndex, elem.zone, elem.health, elem.armor, elem.position)
-        sendResponse(SquadMemberEvent.Add(id, toCharId, toIndex, elem.name, elem.zone, unk7 = 0))
+        val elem = squadUI(fromCharId)
+        squadUI(fromCharId) = SquadUIElement(elem.name, toIndex, elem.zone, elem.health, elem.armor, elem.position)
+        sendResponse(SquadMemberEvent.Remove(id, fromCharId, fromIndex))
+        sendResponse(SquadMemberEvent.Add(id, fromCharId, toIndex, elem.name, elem.zone, unk7 = 0))
         sendResponse(
           SquadState(
             PlanetSideGUID(id),
-            List(SquadStateInfo(toCharId, elem.health, elem.armor, elem.position, 2, 2, false, 429, None, None))
+            List(SquadStateInfo(fromCharId, elem.health, elem.armor, elem.position, 2, 2, false, 429, None, None))
           )
         )
       }
@@ -9233,6 +9256,23 @@ class WorldSessionActor extends Actor with MDCContextAware {
     }
   }
 
+  def NoSquadUpdates() : Unit = { }
+
+  def UpdatesWhenEnrolledInSquad() : Unit = {
+    squadService ! SquadServiceMessage(
+      player,
+      continent,
+      continent.GUID(player.VehicleSeated) match {
+        case Some(vehicle : Vehicle) =>
+          SquadServiceAction.Update(player.CharId, vehicle.Health, vehicle.MaxHealth, vehicle.Shields, vehicle.MaxShields, vehicle.Position, continent.Number)
+        case Some(obj : PlanetSideGameObject with WeaponTurret) =>
+          SquadServiceAction.Update(player.CharId, obj.Health, obj.MaxHealth, 0, 0, obj.Position, continent.Number)
+        case _ =>
+          SquadServiceAction.Update(player.CharId, player.Health, player.MaxHealth, player.Armor, player.MaxArmor, player.Position, continent.Number)
+      }
+    )
+  }
+
   def failWithError(error : String) = {
     log.error(error)
     sendResponse(ConnectionClose())

